//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "EzCapCamera.h"
#include <vfw.h>
#include <jpeg.hpp>
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TEzCapCamera *)
{
        new TEzCapCamera(NULL);
}
//---------------------------------------------------------------------------
__fastcall TEzCapCamera::TEzCapCamera(TComponent* Owner)
        : TPanel(Owner)
{
    JPGCQ = 90;
    CameraMode = PreviewMode;
    Height = 120;
    Width  = 160;
}
//---------------------------------------------------------------------------
namespace Ezcapcamera
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TEzCapCamera)};
                 RegisterComponents("Standard", classes, 0);
        }
}
//]wJPGY~---------------------------------------------------------------
void __fastcall TEzCapCamera::SetCompressionQ(int Value)
{
    JPGCQ = Value;
}
//]wvҦ----------------------------------------------------------------
void __fastcall TEzCapCamera::SetCameraMode(TViewMode Mode)
{
    if (Mode == CameraMode)
        return;
    CameraMode = Mode;
}
//sv--------------------------------------------------------------------
void __fastcall TEzCapCamera::CameraDisplay()
{
    vcHWND = capCreateCaptureWindow("Capture Window",WS_CHILD | WS_VISIBLE,
                                    0, 0, Width, Height, Handle, 0);  //]wjp
    bool ScanDriver = false;
    for(int i=0; i<10; i++)
    {
        ScanDriver = capDriverConnect(vcHWND, i);
        if(ScanDriver) break;
    }
    if(!ScanDriver)
         ShowMessage("vs..");
    if (CameraMode == 0)
    {
        capPreviewRate(vcHWND, 33);
        capPreview(vcHWND, true);
    }
    else
         capOverlay(vcHWND, true);
    capPreviewScale(vcHWND, true);
}
//vu--------------------------------------------------------------------
void __fastcall TEzCapCamera::CameraDisconnect()
{
    capDriverDisconnect(vcHWND);
}
//ve--------------------------------------------------------------------
void __fastcall TEzCapCamera::CameraClose()
{
    capDriverDisconnect(vcHWND);
    DestroyWindow(vcHWND);
}
//]wSource--------------------------------------------------------------------
void __fastcall TEzCapCamera::VideoSourceDlg()
{
    capDlgVideoSource(vcHWND);
}
//]wFormat--------------------------------------------------------------------
void __fastcall TEzCapCamera::VideoFormatDlg()
{
    capDlgVideoFormat(vcHWND);
}
//]wY覡------------------------------------------------------------------
void __fastcall TEzCapCamera::VideoCompressDlg()
{
    capDlgVideoCompression(vcHWND);
}
//^BMPϤ-------------------------------------------------------------------
void __fastcall TEzCapCamera::CapBmpPic(String FileName)
{
    capFileSaveDIB(vcHWND, FileName.c_str());
}
//^JPGϤ-------------------------------------------------------------------
void __fastcall TEzCapCamera::CapJpgPic(String FileName)
{
    Graphics::TBitmap *Source = new Graphics::TBitmap;
    Source->Width =Width;
    Source->Height=Height;
    Source->Canvas->CopyRect(Rect(0, 0, Source->Width, Source->Height),
                             Canvas, Rect(0, 0, Width, Height));
    TJPEGImage* JPG = new TJPEGImage();
    JPG->Assign(Source);
    JPG->SaveToFile(FileName);
    delete Source;
    delete JPG;
}
//^AVI-----------------------------------------------------------------------
void __fastcall TEzCapCamera::CapAVI(String FileName)
{
    capFileSetCaptureFile(vcHWND, FileName.c_str());
    capFileSaveAs(vcHWND, FileName.c_str());
    capCaptureSequence(vcHWND);
}
//------------------------------------------------------------------------------
void __fastcall TEzCapCamera::CapBitmapFrame(Graphics::TBitmap* BMP)
{
    BMP->Width =Width;
    BMP->Height=Height;
    BMP->Canvas->CopyRect(Rect(0, 0, BMP->Width, BMP->Height),
                          Canvas, Rect(0, 0, Width, Height));
}

